#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    for(int T=0; T<t; T++){
        int N,M;
        cin >> N >> M;
        vector<vector<int>> l(N);
        for(int i=0; i<N; i++){
            l[i].resize(M);
            for(int j=0; j<M; j++)
                cin >> l[i][j];
        }
        vector<vector<int>> u(N);
        for(int i=0; i<N; i++){
            u[i].resize(M);
            for(int j=0; j<M; j++)
                cin >> u[i][j];
        }


        bool OK=true;
        vector<vector<int>> m(N);

        for(int i=0; i<N; i++){
            m[i].resize(M);
            for(int j=0; j<M; j++){
                if(l[i][j]==u[i][j])
                    m[i][j]=l[i][j];
                //else if(u[i][j]==l[i][j]-1) m[i][j]
                else m[i][j]=(l[i][j] + u[i][j])/2;
            }
        }




        for(int i=0;i<N;i++)
        {
            for(int j=i;j<N;j++)
            {
                int x=l[i][0]-l[j][0];
              for(int z=1;z<M;z++)
              {
                  if(l[i][z]-l[j][z]!=x){OK=false;break;}
              }
              if(OK==false)break;
            }
            if(OK==false)break;
        }




        if(OK==true){
            cout << "DA" << endl;
        for(int i=0; i<N; i++){
            for(int j=0; j<M; j++)
                cout << m[i][j] << " ";
            cout << endl;
        }
        }
        else
        cout << "NE" << endl;
    }
    return 0;
}